<?php
$vars = array(
	'merchantReference' => $order->order_id,
	'paymentAmount' => $amount,
	'currencyCode' => $this->currency->currency_code,
	'shipBeforeDate' => date('Y-m-d', strtotime('+3 days')),
	'skinCode' => trim($this->payment_params->skincode),
	'merchantAccount' => trim($this->payment_params->merchantaccount),
	'sessionValidity' => date('c',strtotime('+' . (int)$this->payment_params->sessionvalidity . ' days')),
	'shopperLocale' => trim($this->payment_params->language_code),
	'shopperEmail' => $this->user->user_email,
	'shopperReference' => $this->user->user_id,
	//'resURL' => $resURL, // 
	'merchantReturnData' => $resURL,
	'allowedMethods' => preg_replace('#[^a-z0-9_\-,]#i', '', $this->payment_params->allowedmethods),
	'blockedMethods' => preg_replace('#[^a-z0-9_\-,]#i', '', $this->payment_params->blockedmethods),
	'billingAddress.street' => $billing_street,
	'billingAddress.houseNumberOrName' => $billing_house,
	'billingAddress.city' => $order->cart->billing_address->address_city,
	'billingAddress.stateOrProvince' => $order->cart->billing_address->address_state->zone_name,
	'billingAddress.country' => $order->cart->billing_address->address_country->zone_code_2,
	'billingAddress.postalCode' => @$order->cart->billing_address->address_post_code,
	'deliveryAddress.street' => $shipping_street,
	'deliveryAddress.houseNumberOrName' => $shipping_house,
	'deliveryAddress.city' => $order->cart->shipping_address->address_city,
	'deliveryAddress.postalCode' => @$order->cart->shipping_address->address_post_code,
	'deliveryAddress.stateOrProvince' => @$order->cart->shipping_address->address_state->zone_name,
	'deliveryAddress.country' => $order->cart->shipping_address->address_country->zone_code_2,
	'shopper.firstName' => @$order->cart->billing_address->address_firstname,
	'shopper.lastName' => @$order->cart->billing_address->address_lastname,
	'shopper.telephoneNumber' => @$order->cart->billing_address->address_telephone,
); 
		// 1°) Dev for update :
		$vars['allowedMethods'] .
		$vars['billingAddress.city'] .
		$vars['deliveryAddress.houseNumberOrName'] .
		$vars['billingAddress.postalCode'] .
		$vars['billingAddress.stateOrProvince'] .
		$vars['billingAddress.street'] .
		$vars['billingAddressSig'] .
		$vars['blockedMethods'] .
		$vars['currencyCode'] .
		$vars['deliveryAddress.city'] .
		$vars['deliveryAddress.country'] .
		$vars['deliveryAddress.houseNumberOrName'] .
		$vars['deliveryAddress.postalCode'] .
		$vars['deliveryAddress.stateOrProvince'] .
		$vars['deliveryAddress.street'] .
		$vars['deliveryAddressSig'] .
		$vars['merchantAccount'] . 
		$vars['merchantReference'] .
		$vars['merchantReturnData'] .
		$vars['paymentAmount'] .
		$vars['sessionValidity'] .
		$vars['shipBeforeDate'] .
		$vars['shopper.firstName'] .
		$vars['shopper.lastName'] .
		$vars['shopper.telephoneNumber'] .
		$vars['shopperEmail'] .
		$vars['shopperReference'] .
		$vars['shopperSig'] .
		$vars['skinCode'];
		
		$sortedPairs = ksort($vars, SORT_STRING);
	
		foreach ($sortedPairs as $key => $value) {
			$escapedPairs[$key] = str_replace(':','\\:', str_replace('\\', '\\\\', $value));
		}
		$signingString = implode(":", array_merge(array_keys($escapedPairs), array_values($escapedPairs)));
		
		$binaryHmacKey = pack("H*" , $this->payment_params->hmacKey);
		$binaryHmac = hash_hmac('sha1', $signingString, $binaryHmacKey, true);
		$signature = base64_encode($binaryHmac);
		$vars['merchantSig'] = $signature;
		*/
/********************************************************************************************************************************
* 2°) Method
********************************************************************************************************************************/
		// Compute the billingAddressSig
		$vars['billingAddressSig'] = base64_encode(pack('H*', hash_hmac('sha1'/*$this->payment_params->encodagemode*/,
			$vars['billingAddress.street'] . $vars['billingAddress.houseNumberOrName'] . $vars['billingAddress.city'] . $vars['billingAddress.postalCode'] . $vars['billingAddress.stateOrProvince'] . $vars['billingAddress.country'],
			trim($this->payment_params->hmacKey)
		)));

		// Compute the deliveryAddressSig
		$vars['deliveryAddressSig'] = base64_encode(pack('H*', hash_hmac('sha1'/*$this->payment_params->encodagemode*/,
			$vars['deliveryAddress.street'] . $vars['deliveryAddress.houseNumberOrName'] . $vars['deliveryAddress.city'] . $vars['deliveryAddress.postalCode'] . $vars['deliveryAddress.stateOrProvince'] . $vars['deliveryAddress.country'],
			trim($this->payment_params->hmacKey)
		)));

		// Compute the shopperSig
		$vars['shopperSig'] = base64_encode(pack('H*', hash_hmac('sha1'/*$this->payment_params->encodagemode*/,
			$vars['shopper.firstName'] . $vars['shopper.lastName'] . $vars['shopper.telephoneNumber'],
			trim($this->payment_params->hmacKey)
		)));
		
		//create hash->Hmac/adyen
		$vars['merchantSig'] = base64_encode(pack('H*', hash_hmac('sha1'/*$this->payment_params->encodagemode*/,
			$vars['allowedMethods'] .
			$vars['billingAddress.city'] .
			$vars['deliveryAddress.houseNumberOrName'] .
			$vars['billingAddress.postalCode'] .
			$vars['billingAddress.stateOrProvince'] .
			$vars['billingAddress.street'] .
			$vars['billingAddressSig'] .
			$vars['blockedMethods'] .
			$vars['currencyCode'] .
			$vars['deliveryAddress.city'] .
			$vars['deliveryAddress.country'] .
			$vars['deliveryAddress.houseNumberOrName'] .
			$vars['deliveryAddress.postalCode'] .
			$vars['deliveryAddress.stateOrProvince'] .
			$vars['deliveryAddress.street'] .
			$vars['deliveryAddressSig'] .
			$vars['merchantAccount'] . 
			$vars['merchantReference'] .
			$vars['merchantReturnData'] .
			$vars['paymentAmount'] .
			$vars['sessionValidity'] .
			$vars['shipBeforeDate'] .
			$vars['shopper.firstName'] .
			$vars['shopper.lastName'] .
			$vars['shopper.telephoneNumber'] .
			$vars['shopperEmail'] .
			$vars['shopperReference'] .
			$vars['shopperSig'] .
			$vars['skinCode'],
			
/*******************************************************************************************************************************
* 3°) Method
********************************************************************************************************************************/	
			$vars['paymentAmount'] . 
			$vars['currencyCode'] . 
			$vars['shipBeforeDate'] . 
			$vars['merchantReference'] . 
			$vars['skinCode'] . 
			$vars['merchantAccount'] . 
			$vars['sessionValidity'] . 
			$vars['shopperEmail'] . 
			$vars['shopperReference'] . 
			$vars['allowedMethods'] . 
			$vars['blockedMethods'], */
			trim($this->payment_params->hmacKey)
		)));
		